#ifndef _DRAWTOOL_H_
#define _DRAWTOOL_H_

#include <gdk/gdkevents.h>
#include <cairomm/context.h>

#include "Tool.h"
#include "Vertex.h"
#include "Polygon.h"

class PolyDraw;

class DrawTool : public Tool
{
public:
	DrawTool(PolyDraw *pd);
	~DrawTool();

	bool on_mouse_down(GdkEventButton *event);
	bool on_mouse_up(GdkEventButton *event);
	bool on_mouse_move(GdkEventMotion *event);

	bool redraw(Cairo::RefPtr<Cairo::Context>& cr);

private:
	bool down1, down2;

	Polygon* get_round_polygon(int size, int smoothness);
	void subtractPolygonFromDrawArea(Polygon *newpoly);
};

#endif