#ifndef _LINETOOL_H_
#define _LINETOOL_H_

#include <gdk/gdkevents.h>
#include <cairomm/context.h>

#include "Vertex.h"
#include "Line.h"
#include "Tool.h"

class PolyDraw;

class LineTool : public Tool
{
public:
	LineTool(PolyDraw *pd);
	~LineTool();

	bool on_mouse_down(GdkEventButton *event);
	bool on_mouse_up(GdkEventButton *event);
	bool on_mouse_move(GdkEventMotion *event);

	bool redraw(Cairo::RefPtr<Cairo::Context>& cr);

private:
	Line *line;
	Vertex *normal;
	Vertex *intersection;

	void clear();
};

#endif