#include "RemovePolygonTool.h"

#include <list>

#include "Polygon.h"
#include "PolyDraw.h"

RemovePolygonTool::RemovePolygonTool(PolyDraw *pd) : Tool(pd), down(false)
{
	draw->polygons.splice(draw->polygons.end(),draw->selected_polygons);
}

RemovePolygonTool::~RemovePolygonTool()
{
}

bool RemovePolygonTool::on_mouse_down(GdkEventButton *event)
{
	int x = (int) event->x;
	int y = (int) event->y;

	if(event->button == 1)
	{
		removePolygonAtPoint(Vertex(x,-y));
		down = true;
		return true;
	}
	return false;
}

bool RemovePolygonTool::on_mouse_up(GdkEventButton *event)
{
	if(event->button == 1)
	{
		down = false;
	}

	return false;
}

bool RemovePolygonTool::on_mouse_move(GdkEventMotion *event)
{
	if(!down) return false;

	int x = (int) event->x;
	int y = (int) event->y;
	removePolygonAtPoint(Vertex(x,-y));

	return true;
}

bool RemovePolygonTool::redraw(Cairo::RefPtr<Cairo::Context>& cr)
{
	return false;
}

bool RemovePolygonTool::removePolygonAtPoint(const Vertex& point) const
{
	bool ok = false;
	// find polygon to remove
	for(std::list<Polygon *>::iterator it = draw->polygons.begin(); it != draw->polygons.end(); ++it)
	{
		if((*it)->contains(point))
		{
			delete *it;
			draw->polygons.erase(it);
			ok = true;
			break;
		}
	}
	return ok;
}
